//------------------------------------------------------------------------------
//
//  RAMOBJ.H
//
//------------------------------------------------------------------------------
#ifndef _RAMOBJ_H_
#define _RAMOBJ_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define RAMOBJ_MAX                4096
#define RAMOBJ_STACK_MAX          256
#define RAMOBJ_INVALID_ID         0
#define RAMOBJ_GET_STACK(w, t) ((t)(w->stack))
#define RAMOBJ_GEN_ID(x)          (x + 0x100)

//#define _RAMOBJ_TEST_

struct RAMOBJ {
  int id;
  RAMOBJ *next;
  void (*func)(RAMOBJ *);
  char stack[RAMOBJ_STACK_MAX];
};

void ramobj_init(void);
RAMOBJ *ramobj_find_id(int id);
RAMOBJ *ramobj_add(int id, void (*func)(RAMOBJ *));
void ramobj_del(RAMOBJ *w);
int ramobj_update(void);
int ramobj_update_id(int id);

#endif //_RAMOBJ_H_

